# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

pmin3 <- function(vec1, vec2) {
    .Call('_maxnodf_pmin3', PACKAGE = 'maxnodf', vec1, vec2)
}

put_val <- function(mtx, xpos, ypos, val) {
    invisible(.Call('_maxnodf_put_val', PACKAGE = 'maxnodf', mtx, xpos, ypos, val))
}

computeMT0 <- function(mtx) {
    .Call('_maxnodf_computeMT0', PACKAGE = 'maxnodf', mtx)
}

computeMTt <- function(mtx) {
    .Call('_maxnodf_computeMTt', PACKAGE = 'maxnodf', mtx)
}

computeFill0 <- function(mtx) {
    .Call('_maxnodf_computeFill0', PACKAGE = 'maxnodf', mtx)
}

computeFillt <- function(mtx) {
    .Call('_maxnodf_computeFillt', PACKAGE = 'maxnodf', mtx)
}

computeDM0 <- function(mtx) {
    .Call('_maxnodf_computeDM0', PACKAGE = 'maxnodf', mtx)
}

computeDMt <- function(mtx) {
    .Call('_maxnodf_computeDMt', PACKAGE = 'maxnodf', mtx)
}

computeND0 <- function(mtx) {
    .Call('_maxnodf_computeND0', PACKAGE = 'maxnodf', mtx)
}

computeNDt <- function(mtx) {
    .Call('_maxnodf_computeNDt', PACKAGE = 'maxnodf', mtx)
}

computeS <- function(mtx) {
    .Call('_maxnodf_computeS', PACKAGE = 'maxnodf', mtx)
}

nodf_one_link_removed_cpp <- function(mtx, xpos, ypos, mt_0, mt_t, F0, Ft, DM0, DMt, ND0, NDt, S) {
    .Call('_maxnodf_nodf_one_link_removed_cpp', PACKAGE = 'maxnodf', mtx, xpos, ypos, mt_0, mt_t, F0, Ft, DM0, DMt, ND0, NDt, S)
}

nodf_one_link_added_cpp <- function(mtx, xpos, ypos, mt_0, mt_t, F0, Ft, DM0, DMt, ND0, NDt, S) {
    .Call('_maxnodf_nodf_one_link_added_cpp', PACKAGE = 'maxnodf', mtx, xpos, ypos, mt_0, mt_t, F0, Ft, DM0, DMt, ND0, NDt, S)
}

get_valid_ones_cpp <- function(mtx) {
    .Call('_maxnodf_get_valid_ones_cpp', PACKAGE = 'maxnodf', mtx)
}

websearch_cpp <- function(mtx, threshold = 2L) {
    .Call('_maxnodf_websearch_cpp', PACKAGE = 'maxnodf', mtx, threshold)
}

get_zeros_cpp <- function(mtx) {
    .Call('_maxnodf_get_zeros_cpp', PACKAGE = 'maxnodf', mtx)
}

#' Raw NODF calculation
#'
#' Calculates the raw NODF of a bipartite incidence matrix
#' @param mtx A numeric matrix describing a bipartite network (a bipartite incidence matrix where elements are positive numbers if nodes interact, and 0 otherwise).
#' @details For a given network, \code{nodf_cpp} calculates the raw NODF value. Calculation is fast as the code is implemented in C++.
#' @return Returns the NODF of the network.
#' @examples
#' set.seed(123)
#' nodf_cpp(matrix(sample(x = 0:1, size = 100, replace = TRUE),10,10))
#' @useDynLib maxnodf
#' @import Rcpp
#' @export
nodf_cpp <- function(mtx) {
    .Call('_maxnodf_nodf_cpp', PACKAGE = 'maxnodf', mtx)
}

hill_climb_step_cpp <- function(mtx, R = 2L) {
    .Call('_maxnodf_hill_climb_step_cpp', PACKAGE = 'maxnodf', mtx, R)
}

full_hill_climb_cpp <- function(mtx, R = 2L) {
    .Call('_maxnodf_full_hill_climb_cpp', PACKAGE = 'maxnodf', mtx, R)
}

sim_anneal_opt_cpp <- function(mtx, alpha = 0.998, iters = 8L, init_temp = 0.25, min_temp = 0.0001) {
    .Call('_maxnodf_sim_anneal_opt_cpp', PACKAGE = 'maxnodf', mtx, alpha, iters, init_temp, min_temp)
}

